#!/usr/bin/perl -w

use strict;
use Digest::MD5 qw(md5_base64);
use CGI qw(header *html *form *div table hr form font caption TR th td textfield password_field submit param cookie remote_addr user_agent);
use DBI;
require './config.ph';

if (!$::DSN) {
	print
	header (-charset => 'koi8-r'),
	start_html,
	font ({-size => '+1', -color => 'red'}, '     .   config.ph'),
	end_html;
	exit;
}

my ($err, $cookie);
my $dbh = DBI->connect ($::DSN, $::DBUser, $::DBPass, {ShowErrorStatement => 1, AutoCommit => 0});
if (!$dbh) {
	$err = '    : ' . DBI->errstr;
} elsif (grep (defined $_, map param ($_), qw(login aname passwd)) == 3) {
	my $u = $dbh->selectrow_arrayref ("SELECT passwd FROM admins WHERE aname = " . $dbh->quote (param ('aname')));

	if ($dbh->errstr) {
		$err = '    : ' . $dbh->errstr;
	} elsif (!$u || !length $u->[0] || $u->[0] ne param ('passwd')) {
		$err = '   ';
	} else {
		$cookie = md5_base64 (map rand 256, 1 .. 15);
		if ($dbh->do ("UPDATE admins SET cookie = '$cookie' WHERE aname = " . $dbh->quote (param ('aname')))) {
			$dbh->commit;
			$cookie = md5_base64 ($cookie, remote_addr, user_agent, param ('aname'), $u->[0]);
		} else {
			$err = '    : ' . $dbh->errstr;
			undef $cookie;
		}
	}
}
$dbh->disconnect if $dbh;

if ($cookie) {
	print
	header (-cookie => [cookie ('aname', param ('aname'), '/'), cookie ('auth', $cookie, '/')], -location => 'main.cgi');
} else {
	print
	header (-charset => 'koi8-r'),
	start_html (-title => '  ', -encoding => 'koi8-r'),
	start_div ({-align => 'center'}),
	$err ? (font ({-size => '+1', -color => 'red'}, $err), hr) : '',
	start_form,
	table (
		caption (font ({-size => '+1'}, '  ')),
		TR (th (''), td (textfield ('aname', undef, 20, 20))),
		TR (th (''), td (password_field ('passwd', undef, 20, 20))),
		TR (th ({-colspan => 2}, submit ('login', '  ')))
	),
	end_form,
	end_div,
	end_html;
}
